/*jslint browser: true */
/*global KrWindowStack, KrFramework, _hmt*/

var tabs = {
  home: {
    url: '../../trader-native/modules/home/index.html'
  },
  communication: {
    url: '../../trader-native/modules/communication/index.html'
  },
  moments: {
    url: '../../trader-native/modules/moments/index.html',
  },
  questions: {
    url: '../../trader-native/modules/questions/index.html',
  },
  lab: {
    url: '../../trader-native/modules/more/index.html'
  }
};

var ws = new KrWindowStack();

_.forEach($('.tab-content .tab-pane'), function(tabPane) {
  var id = $(tabPane).attr('id');
  var $tabNode = $('.tab-group .' + id);
  var tabNode = $('.tab-group .' + id)[0];
  var initTab;
  var page = KrFramework.createPage({
    src: tabs[id].url,
    parent: tabPane
  }, {
    openPage: function(page) {
      ws.open(page.win);
    },
    closePage: function(page) {
      ws.close(page.win);
    },
    setBadge: function(badge) {
      setBadge(tabNode, badge);
    },
    closeRootPage: function(page) {
      window.location.href = '../entry/index.html'
    }
  });
  initTab = function() {
    page.win.open();
    _hmt.push(['_trackPageview', '/main-window/tabs/' + id]);
  }

  var initTabOnce = _.once(initTab);
  if (id === 'home') {
    initTabOnce();
    $(page.win.iframe).on('load', function() {
      document.addEventListener("deviceready", function() {
        navigator.splashscreen.hide();
      }, false);
    });
  } else {
    $tabNode.on('click', initTabOnce);
  }
})

function setBadge(tabNode, badge) {
  var $badge = $('.badge', tabNode);
  $badge.html(badge);
  if (badge) {
    if(isNaN(badge)) {
      $badge.html(' ');
      $badge.css({'height': '11px', 'width': '11px', 'right': '3px'});
    } else {
      $badge.css({'height': '16px', 'width': '16px', 'right': '0px'});
    }
    $badge.removeClass('hide');
  } else {
    $badge.addClass('hide');
  }
}

document.addEventListener("deviceready", onDeviceReady, false);

function onDeviceReady() {
  document.addEventListener("backbutton", onBackKeyDown, false);
}

var alertOnExitApp = (function() {
  var alert = null;

  return function() {
    if (alert) {
      alert.$dialog.modal('hide');
      alert = null;
    } else {
      alert = new KrAlert({
        title: '离开大操盘手？',
        buttons: ['取消', '离开'],
      }, function(index) {
        if (index === 1) navigator.app.exitApp();
      });
      alert.open();
    }
  }

})();

function onBackKeyDown() {
  var modalPage;
  for (var k in KrFramework.pages) {
    var page = KrFramework.pages[k];
    if (page.win.isModal() || page.win.mode === 'panel') {
      if (!modalPage || $(page.win.iframe).css('z-index') > $(modalPage.win.iframe).css('z-index')) {
        modalPage = page;
      }
    }
  };

  if (modalPage) {
    if (modalPage.win.src.indexOf('/modules/training/index.html') !== -1) return;
    if (modalPage.win.src.indexOf('/modules/pk/pk-index.html') !== -1) return;
    if (!modalPage.closePage) {
      modalPage.win.close();
    } else {
      modalPage.closePage(modalPage);
    }
  } else {
    if (ws.top()) {
      ws.close();
    } else {
      alertOnExitApp();
    }
  }
}
